%define upstream_name    PDL
%define upstream_version 2.015

%define Werror_cflags %nil

Name:       perl-%{upstream_name}
Version:    %perl_convert_version %{upstream_version}
Release:    %mkrel 2
Epoch:      2

Summary:    PerlDL, an efficient numerical language for scientific computing
License:    GPL
Group:      Development/Perl
Url:        http://search.cpan.org/dist/%{upstream_name}/
Source0:    http://cpan.metacpan.org/authors/id/C/CH/CHM/%{upstream_name}-%{upstream_version}.tar.gz
Source1:    PDL-convert-doc.pl.bz2
Patch1:     PDL-2.4.4-fpic.patch
Patch2:     PDL-2.4.4-handle-INSTALLDIRS-vendor.patch
# Hacks for fixing writing permissions
Patch3:     PDL-2.012-direct-pod2html-to-writable-directory_and_make_html_files_writable.patch
Patch4:     PDL-2.4.0-fix-gimp.patch
Patch5:     PDL-2.4.2-makemakerfix.patch
# Remove Proj stiff which is not built but breaks doc building
Patch6:     PDL-2.007-no-Proj.patch
Patch7:     PDL-2.007-gsl2.patch

BuildRequires: perl(Astro::FITS::Header)
BuildRequires: perl(CPAN::Meta) >= 2.120.900
BuildRequires: perl(Carp)
BuildRequires: perl(Config)
BuildRequires: perl(Convert::UU)
BuildRequires: perl(Data::Dumper) >= 2.121.0
BuildRequires: perl(Devel::CheckLib) >= 1.10.0
BuildRequires: perl(English)
BuildRequires: perl(ExtUtils::MakeMaker) >= 6.560.0
BuildRequires: perl(ExtUtils::Manifest)
BuildRequires: perl(ExtUtils::ParseXS) >= 3.10.0
BuildRequires: perl(Fcntl)
BuildRequires: perl(File::Basename)
BuildRequires: perl(File::Find)
BuildRequires: perl(File::Map) >= 0.570.0
BuildRequires: perl(File::Path)
BuildRequires: perl(File::Spec) >= 0.600.0
BuildRequires: perl(File::Temp)
BuildRequires: perl(Filter::Simple) >= 0.880.0
BuildRequires: perl(Filter::Util::Call)
BuildRequires: perl(IPC::Cmd) >= 0.720.0
BuildRequires: perl(Inline) >= 0.680.0
BuildRequires: perl(Inline::C) >= 0.620.0
BuildRequires: perl(Module::Compile) >= 0.230.0
BuildRequires: perl(OpenGL) >= 0.670.200
BuildRequires: perl(Pod::Parser)
BuildRequires: perl(Pod::Select)
BuildRequires: perl(Scalar::Util)
BuildRequires: perl(Storable) >= 1.30.0
BuildRequires: perl(Test::Deep)
BuildRequires: perl(Test::Exception)
BuildRequires: perl(Test::Warn)
BuildRequires: perl(Text::Balanced) >= 1.890.0
BuildRequires: gcc-gfortran
BuildRequires: libgsl-devel
BuildRequires: mesaglu-devel
BuildRequires: freeglut-devel
BuildRequires: ncurses-devel
BuildRequires: perl-devel
BuildRequires: perl-ExtUtils_F77 >= 1.14-11mdk
BuildRequires: libx11-devel
BuildRequires: libxext-devel
BuildRequires: libxi-devel
BuildRequires: libxmu-devel
# if installed, requires f2c-devel,
# but it is a contrib package
BuildConflicts: f2c

Provides:   perl(PDL::PP::CType)
Provides:   perl(PDL::PP::Dims)
Provides:   perl(PDL::PP::PDLCode)
Provides:   perl(PDL::PP::SymTab)
Provides:   perl(PDL::PP::XS)
Provides:   perl(PDL::Config)
Provides:   perl(PDL::Graphics::OpenGL)
Provides:   perl(PDL::Graphics::OpenGLQ)
Provides:   perl(PDL::Graphics::TriD::GL)
Provides:   perl(PDL::Graphics::TriD::Objects)
Provides:   perl()
Provides:   perl(PDL::Lite)
Provides:   perl(PDL::LiteF)
Provides:   perl(PGPLOT)

Obsoletes:  PDL
Provides:   PDL

%{?perl_default_filter}
#global __provides_exclude perl\\(Inline\\)
#global __requires_exclude perl\\((Devel::REPL::Plugin|Inline|PDL|PDL::Demos::Screen|PDL::Graphics::Gnuplot|PDL::Graphics::TriD|PDL::Graphics::TriD::Image|PDL::IO::HDF::SD|PDL::IO::HDF::VS|PDL::Graphics::Gnuplot|PGPLOT|Prima::MsgBox)\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\((OpenGL::Config|PDL::Demos::Screen|(Prima[A-Za-z:_]*)|Tk|Win32::DDE::Client)\\)$
%global __provides_exclude %{?__provides_exclude:%__provides_exclude|}^perl\\(Inline\\)$
%global __provides_exclude %__provides_exclude|^perl\\(Win32.*\\)$
# Remove under-specified dependencies
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\((%%s|Data::Dumper|File::Spec|Filter::Simple|Inline|Module::Compile|OpenGL|Text::Balanced)\\)$

%description

%package    doc
Summary:    PerlDL documentation package
Group:      Documentation
Requires:   perl-PDL
%description
The perlDL project aims to turn perl into an efficient numerical language for
scientific computing. The PDL module gives standard perl the ability to
COMPACTLY store and SPEEDILY manipulate the large N-dimensional data sets which
are the bread and butter of scientific computing. e.g. C<$a=$b+$c> can add two
2048x2048 images in only a fraction of a second.

The aim is to provide tons of useful functionality for
scientific and numeric analysis.

%description    doc
The perlDL project aims to turn perl into an efficient numerical language for
scientific computing. The PDL module gives standard perl the ability to
COMPACTLY store and SPEEDILY manipulate the large N-dimensional data sets which
are the bread and butter of scientific computing. e.g. C<$a=$b+$c> can add two
2048x2048 images in only a fraction of a second.

The aim is to provide tons of useful functionality for
scientific and numeric analysis.

This is the documentation package.

%prep
%setup -q -n %{upstream_name}-%{upstream_version}
%patch1 -p1 -b .pic
%patch2 -p1 -b .vendor
%patch3 -p1 -b .writable-cachedir
%patch4 -p0 -b .gimp
%patch5 -p0 -b .mm
%patch6 -p1 -b .proj
%patch7 -p1 -b .gsl2

%build
echo | %__perl Makefile.PL INSTALLDIRS=vendor PREFIX=%{_prefix} OPTIMIZE="%{optflags}"
make
#DISPLAY="" make test

# first generate blib/lib/PDL/pdldoc.db
make doctest

%install
%makeinstall PREFIX="%{buildroot}/%{_prefix}"

# create /usr/bin if it doesn't already exist
%__mkdir_p %{buildroot}%{_bindir}

# fix installed documentation
%__bzip2 -dc %{SOURCE1} | %__perl - "%{buildroot}"

%files
%doc COPYING Changes DEPENDENCIES DEVELOPMENT Demos Example GENERATED INSTALL INTERNATIONALIZATION IO META.json META.yml MYMETA.yml README TODO
%doc DEVELOPMENT INSTALL
%{_bindir}/*
%{_mandir}/*/*
%{perl_vendorarch}/PDL.pm
%{perl_vendorarch}/PDL
%{perl_vendorarch}/auto/PDL
%{perl_vendorarch}/Inline
%exclude %{perl_vendorarch}/PDL/*.pod
%exclude %{perl_vendorarch}/PDL/HtmlDocs

%files doc
%doc COPYING
%{perl_vendorarch}/PDL/*.pod
%{perl_vendorarch}/PDL/HtmlDocs


%changelog
* Fri Jun 03 2016 joequant <joequant> 2:2.15.0-2.mga6
+ Revision: 1020145
- add pic for arm compile

* Sun May 08 2016 shlomif <shlomif> 2:2.15.0-1.mga6
+ Revision: 1010756
- update to 2.015

* Tue Jan 26 2016 luigiwalser <luigiwalser> 2:2.14.0-2.mga6
+ Revision: 927782
- add patch from debian to fix build with gsl version 2
- rebuild for gsl

* Wed Oct 14 2015 sander85 <sander85> 2:2.14.0-1.mga6
+ Revision: 891513
- update to 2.014

* Sun Aug 23 2015 sander85 <sander85> 2:2.13.0-1.mga6
+ Revision: 868638
- update to 2.013

* Tue Aug 04 2015 shlomif <shlomif> 2:2.12.0-4.mga6
+ Revision: 861055
- Remove unnecessary Requires on perl-Prima

* Fri Jun 26 2015 tv <tv> 2:2.12.0-3.mga6
+ Revision: 845098
- rebuild for soname-ifed perl

* Wed Jun 24 2015 sander85 <sander85> 2:2.12.0-2.mga6
+ Revision: 842083
- Add some hacks to fix writing permissions during doc generation

* Wed Jun 24 2015 shlomif <shlomif> 2:2.12.0-1.mga6
+ Revision: 842032
- New version 2.012 + Rebuild for the new perl-5.22.0

* Wed Oct 15 2014 umeabot <umeabot> 2:2.7.0-6.mga5
+ Revision: 750060
- Second Mageia 5 Mass Rebuild

* Fri Oct 03 2014 tv <tv> 2:2.7.0-5.mga5
+ Revision: 736608
- add missing provides

* Thu Oct 02 2014 tv <tv> 2:2.7.0-4.mga5
+ Revision: 735149
- add exclude

* Tue Sep 23 2014 tv <tv> 2:2.7.0-3.mga5
+ Revision: 722231
- use %%perl_default_filter

* Tue Sep 16 2014 umeabot <umeabot> 1:2.7.0-3.mga5
+ Revision: 685802
- Mageia 5 Mass Rebuild

  + tv <tv>
    - use %%global for req/prov exclude
    - autoconvert to new prov/req excludes

* Tue Jun 03 2014 jquelin <jquelin> 1:2.7.0-2.mga5
+ Revision: 632475
- perl 5.20.0 rebuild

* Fri Jan 17 2014 shlomif <shlomif> 1:2.7.0-1.mga4
+ Revision: 566772
- Upgrade to PDL-2.007.
  In the process did some cleanups to the .spec like removing trailing space
  or removing unneeded %%doc files.
  This fixes the test suite of AI-Pathfinding-OptimizeMultiple which uncovered
  an XS bug in PDL.

* Tue Dec 31 2013 pterjan <pterjan> 1:2.6.0-3.mga4
+ Revision: 563375
- Fix patch 2
- Add a patch to ignore broken subdirs that we dont want anyway

  + umeabot <umeabot>
    - Mageia 4 Mass Rebuild

* Mon Jun 10 2013 jquelin <jquelin> 1:2.6.0-1.mga4
+ Revision: 441808
- update to 2.006

* Wed May 29 2013 tv <tv> 1:2.4.11-4.mga4
+ Revision: 432728
- rebuild for new perl

* Sun Jan 13 2013 umeabot <umeabot> 1:2.4.11-3.mga3
+ Revision: 371200
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Oct 10 2012 jquelin <jquelin> 1:2.4.11-2.mga3
+ Revision: 304082
- fix rpm group

* Wed Jun 06 2012 jquelin <jquelin> 1:2.4.11-1.mga3
+ Revision: 256139
- update to 2.4.11

* Wed May 30 2012 jquelin <jquelin> 1:2.4.10-2.mga3
+ Revision: 251045
- rebuild for perl 5.16

* Fri Feb 24 2012 jquelin <jquelin> 1:2.4.10-1.mga2
+ Revision: 213789
- update to 2.4.10

* Sat Dec 10 2011 kharec <kharec> 1:2.4.9_13-1.mga2
+ Revision: 180459
- New version 2.4.9_013

* Thu Sep 29 2011 fwang <fwang> 1:2.4.9-3.mga2
+ Revision: 150194
- tighten br

* Sun Jun 12 2011 sander85 <sander85> 1:2.4.9-2.mga2
+ Revision: 104412
- Rebuild for perl 5.14

* Tue Apr 12 2011 jquelin <jquelin> 1:2.4.9-1.mga1
+ Revision: 83803
- update to 2.4.9

* Fri Apr 08 2011 jquelin <jquelin> 1:2.4.8-1.mga1
+ Revision: 82247
- update to 2.4.8

* Sat Jan 22 2011 jquelin <jquelin> 1:2.4.7-2.mga1
+ Revision: 32285
- mageia rebuild
- imported package perl-PDL

